/*
 irc.h made by Sorunome
 Feel free to use this.
 make a object:
 irc irc;
 to use it include it into your main file and make two functions:
 void handleMsgActions(string message,string action,string nickName,string ident,string command,string args)
 void handleNormalActions(string message,string action,string nickName,string ident,string command,string args,string postChannel,bool omnom)
 they do what they say, store into irc.sbuf what to send, it'll send automaticly.
 To start it enter:
 irc.construct(<server>,<name>,<channel>,<admin md5-hash>);
 irc.mainLoop();
 
 Admin commands (via pm)
 goadmin <passwd>
 join <channel>
 part <channel>
 tell <channel>
 raw <raw code>
 
 DO NOT PRETEND THIS WAS YOUR HEADER FILE
 
 md5.h is copied from the internet and is not mine
 */
#ifndef IRC_H
#define IRC_H
#include <string>
#include "md5.h"
void handleMsgActions(std::string message,std::string action,std::string nickName,std::string ident,std::string command,std::string args,int omnom);
void handleNormalActions(std::string message,std::string action,std::string nickName,std::string ident,std::string command,std::string args,std::string postChannel,int omnom);
std::string toLower(std::string string) {
	transform(string.begin(), string.end(), string.begin(), ::tolower);
	return string;
}
class irc {
public:
	std::string server;
	std::string port;
	std::string nick;
	std::string channel;
	std::string sbuf;
	std::string sbuf2;
	std::string sbuf3;
	std::string message;
	std::string nickName;
	std::string command;
	std::string ident;
	std::string args;
	std::string postChannel;
	std::string action;
	std::string rbuf;
	std::string passwd;
	int omnom;
	char charTemp[512];
	int sock;
	bool efnet;
	struct addrinfo *address;
	void sendSbuf() {
		send(sock,sbuf.c_str(),sbuf.size(),0);
	}
	void sendSbuf2() {
		send(sock,sbuf2.c_str(),sbuf2.size(),0);
	}
	void sendSbuf3() {
		send(sock,sbuf3.c_str(),sbuf3.size(),0);
	}
	void constructAddress() {
		int gai_err = getaddrinfo(server.c_str(),port.c_str(), NULL, &address);
		std::cout << "gai_err (IRC): " << gai_err << " " << gai_strerror(gai_err) << std::endl;
	}
	void openSocket() {
		sock = socket(address->ai_family, address->ai_socktype, address->ai_protocol);
		connect(sock, address->ai_addr, address->ai_addrlen);
	}
	void closeSocket() {
		close(sock);
	}
	void setNick() {
		sbuf = "NICK " + nick + "\nUSER " + nick + " 0 * :" + nick + "\r\n";
		sendSbuf();
	}
	void joinChannel(std::string chan) {
		sbuf = "JOIN " + chan + "\n";
		sendSbuf();
	}
	irc(std::string serverb,std::string nickb,std::string channelb,std::string passwdb,bool efnetb) {
		passwd = passwdb;
		server = serverb;
		port = "6667";
		nick = nickb;
		channel = channelb;
		efnet = efnetb;
		constructAddress();
		openSocket();
		setNick();
		joinChannel(channel);
	}
	void handleQuitMessage() {
		if (action == "QUIT" && nickName == nick) {
			closeSocket();
			openSocket();
			setNick();
			joinChannel(channel);;
		}
	}
	void handleMsgCommands() {
		if (command=="goadmin") {
			command = args.substr(0,args.find(" "));
			args =  args.substr(args.find(" ")+1);
			if (md5(command)==passwd) {
				command = args.substr(0,args.find(" "));
				args =  args.substr(args.find(" ")+1);
				if (command=="join")
					sbuf = "JOIN " + args + "\n";
				if (command=="part")
					sbuf = "PART " + args + "\n";
				if (command=="tell")
					sbuf = "PRIVMSG " + args.substr(0,args.find(" ")) + " :" + args.substr(args.find(" ")+1) + "\n";
				if (command=="raw")
					sbuf = args + "\n";
			} else
				sbuf = "NOTICE " + nickName + " :Wrong password.\n";
		} else
			handleMsgActions(message,action,nickName,ident,command,args,omnom);
	}
	void loadMessageData() {
		message = rbuf.substr(rbuf.find(":")+1);
		message = message.substr(0,message.size()-2); // \r\n raus machen
		
		action = message.substr(message.find(" ")+1);
		action = action.substr(0,action.find(" "));
		
		nickName = message.substr(0,message.find("!"));
		ident = message.substr(message.find("@")+1);
		ident = ident.substr(0,ident.find(" "));
		ident = nickName + "@" + ident;
		message = message.substr(message.find(":")+1);
		command = message.substr(0,message.find(" "));
		args = message.substr(message.find(" ")+1);
		
		postChannel = rbuf.substr(rbuf.find(" ")+1);
		postChannel = postChannel.substr(postChannel.find(" ")+1);
		postChannel = postChannel.substr(0,postChannel.find(" "));			
		toLower(command);
		toLower(args);
		if (efnet)
			omnom = 0;
		else
			omnom = 1;
		if (nickName == "OmnomIRC" || nickName == "Netham45_") {
			if (message.substr(0,3)=="(#)" && efnet)
				omnom = 1;
			else if (!efnet)
				omnom = 0;
			else
				omnom = 2;
			nickName = message.substr(0,message.find(">"));
			nickName = nickName.substr(message.find("<")+1);
			message = message.substr(message.find("> ")+2);
			command = message.substr(0,message.find(" "));
			args = message.substr(message.find(" ")+1);
			ident = nickName+"@OmnomIRC";
		}
		handleQuitMessage();
		if (postChannel==nick)
			handleMsgCommands();
		else if ((omnom==0 && efnet) || (omnom==1 && !efnet) || (omnom==2 && efnet))
			handleNormalActions(message,action,nickName,ident,command,args,postChannel,omnom);
		if (sbuf!="")
			sendSbuf();
		sbuf = "";
	}
	void handlePing() {
		if (rbuf.find("PING")==0) { //ping regeln
			sbuf = rbuf.replace(0,4,"PONG");
			send(sock, sbuf.c_str(), sbuf.size(), 0);
		}
	}
	void mainLoop() {
		int brecv;
		while((brecv=recv(sock,charTemp,sizeof(charTemp),0)) > 0) {
			rbuf.assign(charTemp, brecv);
			std::cout << rbuf << std::endl;
			handlePing();
			if (rbuf.substr(0,1)==":")
				loadMessageData();
		}
	}
};

#endif
